unit Vraag1_UMemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TfrmVraag1 = class(TForm)
    pgcVraag1: TPageControl;
    tsQ1_1: TTabSheet;
    pnlButtons: TPanel;
    bmbClose: TBitBtn;
    tsQ1_3: TTabSheet;
    tsQ1_2: TTabSheet;
    lblMarkWaarde: TLabel;
    lblVerkoopprys: TLabel;
    lblSlaapkamers: TLabel;
    lblBadkamers: TLabel;
    chkSwembad: TCheckBox;
    btnVerkoopsAdvertensie: TButton;
    edtMarkwaarde: TEdit;
    edtVerkoopprys: TEdit;
    edtSlaapkamers: TEdit;
    edtBadkamers: TEdit;
    lblOpskrifKiloW: TLabel;
    lblVorigeLesing: TLabel;
    lblHuidigeLesing: TLabel;
    lblElektrisiteit: TLabel;
    lblGeiserGroottes: TLabel;
    edtVorige: TEdit;
    edtHuidig: TEdit;
    edtGrootte: TEdit;
    lblOpknapArea: TLabel;
    lblVMeter: TLabel;
    redOpknapping: TRichEdit;
    btnBerekenOpknapping: TButton;
    btnVindGeisers: TButton;
    grpOpknappingsArea: TGroupBox;
    grpElektrisiteitGebruik: TGroupBox;
    btnBerekenBedrag: TButton;
    lblBedragVerskuldig: TLabel;
    grpGeiserOpsies: TGroupBox;
    grpAdvertensie: TGroupBox;
    redV1: TRichEdit;
    rgbVerf: TRadioButton;
    rgbTeel: TRadioButton;
    memGeisers: TMemo;
    grpOpknappingsMetode: TGroupBox;
    edtArea: TEdit;
    procedure btnVerkoopsAdvertensieClick(Sender: TObject);
    procedure btnBerekenOpknappingClick(Sender: TObject);
    procedure btnBerekenBedragClick(Sender: TObject);
    procedure rgbVerfClick(Sender: TObject);
    procedure rgbTeelClick(Sender: TObject);
    procedure btnVindGeisersClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraag1: TfrmVraag1;
  cTipeOpknap : char;
  arrGeisers  : array [1..20] of string = ('50-QuickSun50','100-QuickSun100','150-QuickSun150','50-Solar Magic','50-InHotWater',
                                          '100-SunnyBath 100','150-SunnyBath 150','50-WaterJoy 50','100-WaterJoy 100',
                                          '150-BigTub 150','50-Small Wonder','100-Medium Wonder','150-Large Wonder',
                                          '100-SolarWarmth 100','150-SolarWarmth 150','50-Sun Magic','50-Eco Wonder 50',
                                          '100-Eco Wonder 100','150-Eco Wonder 150','150-Big Earth Saver');

implementation
{$R *.dfm}
{$R+}

procedure TfrmVraag1.btnVerkoopsAdvertensieClick(Sender: TObject);
var
   rMarkWaarde, rVerkoop : real;
   sAdvertensie          : string;
   iBed, iBad            : integer;
begin
   // Vraag 1.1
   rMarkWaarde := StrToFloat(edtMarkwaarde.Text);
   rVerkoop    := StrToFloat(edtVerkoopprys.Text);
   iBed        := StrToInt(edtSlaapkamers.Text);
   iBad        := StrToInt(edtBadkamers.Text);
   sAdvertensie := 'R' + FloatToStr(rVerkoop) + '#' +
                   IntToStr(iBed) + 'Bed#' + IntToStr(iBad) + 'Bad#';
   if chkSwembad.Checked then
      sAdvertensie := sAdvertensie + 'Swembad#';

   if rVerkoop < rMarkWaarde then
      sAdvertensie := sAdvertensie + 'Winskoop';

   redV1.Lines.Clear;
   redV1.Lines.Add('Huis te koop:' + #13 + sAdvertensie);
end;
//====================================================================
procedure TfrmVraag1.rgbVerfClick(Sender: TObject);
begin
    // Vraag 1.2.1
    cTipeOpknap := 'V';
end;
//====================================================================
procedure TfrmVraag1.rgbTeelClick(Sender: TObject);
begin
    // Vraag 1.2.2
   cTipeOpknap := 'T';
end;
//====================================================================
procedure TfrmVraag1.btnBerekenOpknappingClick(Sender: TObject);
var
  rKoste, rLiterVerf, rDromkoste, rTeelKoste : real;
  iOppervlakte, iVolLiter, iEenLiter, iTweeLiter, iVyfLiter : integer;
begin
   // Vraag 1.2.3
   iOppervlakte := StrToInt(edtArea.Text);
   iEenLiter  := 0;
   iTweeLiter := 0;
   iVyfLiter  := 0;
   rKoste     := 0;
   iVolLiter  := 0;
   rLiterVerf := 0;
   rDromkoste    := 0;
   rTeelKoste    := 0;

   if cTipeOpknap = 'V' then
     begin
       rLiterVerf := iOppervlakte / 8;
       iVolLiter  := Round(rLiterVerf + 0.4);
      // Alternatief  >> Afronding na naaste heelgetal
      // iVolLiter := Round(rLiterVerf);
      // if (iArea mod 8 > 0)
      //   then iVolLiter := iVolLiter + 1;

       if (iVolLiter div 5) > 0 then
         begin
           iVyfLiter := iVolLiter div 5;
           dec(iVolLiter, (iVyfLiter * 5));
           rKoste := rKoste + (iVyfLiter * 199.00);
         end;

       if (iVolLiter div 2) > 0 then
         begin
           iTweeLiter := iVolLiter div 2;
           dec(iVolLiter, (iTweeLiter * 2));
           rKoste := rKoste + (iTweeLiter * 92.30);
         end;

       iEenLiter := iVolLiter;
       rKoste    := rKoste + (iEenLiter * 55.50);

       redOpknapping.Lines.Clear;
       redOpknapping.Lines.Add('Oppervlakte: ' + IntToStr(iOppervlakte) + ' vierkante meter' +
            #13 +
          'Volume verf wat benodig word: ' + FloatToStrF(rLiterVerf, ffFixed, 8,2) +
          ' liter' + #13 + #13 +
          '1 liter-dromme: ' + #9 + IntToStr(iEenLiter) + #13 +
          '2 liter-dromme: ' + #9 + IntToStr(iTweeLiter) + #13 +
          '5 liter-dromme: ' + #9 + IntToStr(iVyfLiter) +#13 +
          #13 +
          'Totale koste: R ' + FloatToStrF(rKoste, ffFixed, 8, 2));
     end;//verf

   if cTipeOpknap = 'T' then
     begin
       rTeelKoste := StrToFloat(Inputbox('Teelkoste',
               'Sleutel die koste per vierkante meter in', ''));
       rKoste := (iOppervlakte + 5) * rTeelKoste;
       redOpknapping.Lines.Clear;
       redOpknapping.Lines.Add('Oppervlakte: ' + IntToStr(iOppervlakte) +' vierkante meter' +
                #13 +
                'Totale koste: R ' + FloatToStrF(rKoste, ffFixed, 8, 2));
     end;//teel
end;
//====================================================================
procedure TfrmVraag1.btnBerekenBedragClick(Sender: TObject);
var
  rGebruik, rBedrag       : real;
  iVorigeLesing, iHuidigeLesing : integer;
begin
  // Vraag 1.3.1
  iVorigeLesing  := StrToInt(edtVorige.Text);
  iHuidigeLesing := StrToInt(edtHuidig.Text);

  if (iVorigeLesing > iHuidigeLesing) then
    begin
      MessageDlg('Vorige lesing groter as huidige lesing. Sleutel weer in',
                   mtError, [mbOk], 0);
      edtHuidig.Clear;
      rBedrag := 0;
    end
   else
    begin
      rGebruik := iHuidigeLesing - iVorigeLesing;
      if rGebruik <= 600 then
         rBedrag := rGebruik
      else
         rBedrag := 600 + (rGebruik - 600) * 1.5;
    end;
   lblElektrisiteit.Caption := FloatToStrF(rBedrag, ffCurrency, 8,2);
end;
//====================================================================
procedure TfrmVraag1.btnVindGeisersClick(Sender: TObject);
var
   K : integer;
   sGrootte, sGeiser : String;
begin
  // Vraag 1.3.2
  memGeisers.Clear;
  for K := 1 to 20 do
   begin
     sGeiser := arrGeisers[K];
     sGrootte   := copy(sGeiser, 1, pos('-', sGeiser)-1);
     Delete(sGeiser, 1, pos('-', sGeiser));
     if sGrootte = edtGrootte.Text then
        memGeisers.Lines.Add(sGeiser);
   end;

end;
//====================================================================


end.
