unit HuisLening_UMemo;
   //Oplossing vir vraag 2 "class unit"

interface

uses
  SysUtils, Math, Messages, Dialogs;

Type
  THuisLening = class(TObject)
  // Vraag 2.1.1
    fAansoekerNaam : string;
    fBesteebareInkomste,
    fLeningBedrag  : real;
    fJare          : integer;
    fRentekoers    : real;

   public
    function berekenPaaiement  : real;
    constructor Create(pAansoekerNaam : String; pBesteebareInkomste, pLeningBedrag : real);
    function GetAansoekerNaam : String;
    procedure SetJare(pJare : integer);
    procedure SetRentekoers(pRentekoers : real);
    function isGoedgekeur : boolean;
    function toString : String;
  end;

implementation

{ THuisLening }

 function THuisLening.berekenPaaiement: real;
 var
   rBedrag, rKoers : real;
 begin
   rKoers := fRenteKoers / 100;
   rBedrag := (rKoers * fLeningBedrag)/(1-Power((1+rKoers),-fJare));
   Result := Round(rBedrag / 12);
 end;

constructor THuisLening.Create(pAansoekerNaam: String; pBesteebareInkomste,
  pLeningBedrag: real);
begin
    fAansoekerNaam      := pAansoekerNaam;
    fBesteebareInkomste := pBesteebareInkomste;
    fLeningBedrag      := pLeningBedrag;
    fJare              := 0;
    fRentekoers        := 0;
end;

function THuisLening.GetAansoekerNaam: String;
begin
    result := fAansoekerNaam;
end;

procedure THuisLening.SetJare(pJare: integer);
begin
   fJare := pJare;
end;

procedure THuisLening.SetRentekoers(pRentekoers: real);
begin
  fRentekoers := pRentekoers;
end;

function THuisLening.isGoedgekeur: boolean;
var
  bGeldig : boolean;
begin
  bGeldig := True;

  if (fLeningBedrag > 800000)
   then bGeldig := (fJare > 20);

  if (fLeningBedrag <= 600000)
   then bGeldig := fBesteebareInkomste > (berekenPaaiement * 1.3);

  Result := bGeldig;
end;

function THuisLening.toString: String;
begin
   Result := 'Naam van aansoeker: ' + fAansoekerNaam + #13 +
             'Besteebare inkomste: R ' + FloatToStrF(fBesteebareInkomste,
                                 ffFixed, 8, 2) + #13 +
             'Leningbedrag: R ' + FloatToStrF(fLeningBedrag, ffFixed, 8, 2) +
       #13+  'Getal jaar: ' + IntToStr(fJare) + #13 +
             'Rentekoers: ' + FloatToStrF(fRentekoers, ffFixed, 8,1) + '%' +
             #13;
end;

end.
